;2.Semestralni projekt z SOJ
;Autor: KOSTURIK Martin (L95289)
;Komprimacni program vyuzivajici metodu LZH

.MODEL SMALL
.386

.DATA
cmd	db	80h DUP('$')
buf     db      ' ','$'
byte1	db	0
byte2	db	0
pocet	db	0

error1  db      'Komprimacni program vyuzivajici metodu LZH',10,13,'$'
error2  db      'Autor: KOSTURIK Martin @1999',10,13,'$'
error3  db      'Syntaxe: LZH.exe -[k|d] <Vstup >Vystup',10,13,'$'
error4  db      '         -k ... komprimovat',10,13,'$'
error5  db      '         -d ... dekomprimovat',10,13,'$'

.CODE
	INIC MACRO XS
		push AX	
		mov AX,@DATA
		mov XS,AX
		pop AX
	ENDM

        TISKNI MACRO STROFF
                mov dx,STROFF
                mov ah,09h
                int 21h
        ENDM

	mov AX,@DATA			
	mov SI,80h			;nacteni prikazove radky
	movzx CX,byte ptr DS:[SI]
        inc CX
	INIC ES
	mov DI,offset cmd
	cld
	rep movsb

	mov CX,DI			;prevod prikazove radky na velka pismena
	sub CX,offset cmd
	INIC DS
	mov BX,offset cmd
zpet:	cmp byte ptr [BX],'a'
	jb mimo
	cmp byte ptr [BX],'z'
	ja mimo
	sub byte ptr [BX],'a'-'A'
mimo:	inc BX
	loop zpet		

	mov DX,offset buf               ;buf

        mov AL,[cmd+2]			;zpracovani prikazove radky
        cmp AL,'-'
        jne Chyba
	mov AL,[cmd+3]
        cmp AL,'K'
        jne Next
	jmp Kompr
Next:	cmp AL,'D'
	jne Chyba			;nespravne parametry (tisk navodu)
	jmp Dekom


;KOMPRIMACE
Kompr:	call Vstup		;precteni prvniho znaku
	mov BL,[buf]
	mov byte1,BL		;vybrani znaku z buferu
Duplic:	call Vstup		;precteni dalsiho znaku
	mov BH,[buf]
	mov byte2,BH
	cmp byte1,BH		;srovnani prvniho a posledne nacteneho znaku
	jne NonDup
	inc pocet		;pocet stejnych za sebou nasledujicich znaku + 1
	cmp pocet,127		;rozdeleni znaku z ASCII na dve poloviny
	je NonDup
	jmp Duplic
NonDup:	cmp pocet,0		;rozdeleni dle poctu stejnych znaku v rade
	jne KLoop		;podminka zda komprimovat nebo ne
	cmp byte1,127
	jna OneB
KLoop:	add pocet,128		;pricteni 128 jako priznak zakodovaneho slova
	mov CL,pocet
	mov [buf],CL
	call Vystup		;vystup zakodovaneho poctu opakovani znaku
OneB:	mov BL,byte1
	mov [buf],BL
	call Vystup		;vystup znaku
	mov BH,byte2
	mov byte1,BH
	mov pocet,0
	jmp DUplic		;zpracovani zbyvajici casti vstupniho retezce

	
;DEKOMPRIMACE
Dekom:	call Vstup
	mov BL,[buf]		;vstup znaku z buferu
	cmp BL,127		;test na priznak zakodovaneho slova
        ja DLoop
	call Vystup		;vystup nekomprimovaneho znaku
	jmp Dekom
DLoop:	sub BL,127		;zacatek komprimace
	mov byte1,BL		;odstraneni priznaku = pocet opakovani	
	call Vstup
Print:	call Vystup		;smycka pro vystup n-znaku 
	dec byte1
	jz Dekom
	jmp Print
	
Chyba:  TISKNI <offset error1>		;tisk navodu
        TISKNI <offset error2>
        TISKNI <offset error3>
        TISKNI <offset error4>
        TISKNI <offset error5>

Konec:	mov AH,4Ch			;ukonceni programu
	int 21h

Vstup: 	mov AH,3fh                      ;cteni
        mov BX,0                        ;vstup z STDIN
        mov CX,1                        ;kolik znaku cteme
 	mov DX,offset buf               ;buf
	int 21h
	cmp AX,0
        jz Konec                        ;AX - vraci pocet prectenych znaku
	ret

Vystup: mov AH,40h
	mov BX,1			;vystup na STDIN
	mov CX,1
	mov DX,offset buf               ;buf
	int 21h
	ret

END
